SystemOrganization addCategory: #'CodeImport-Tests'!

TestCase subclass: #ChunkImportTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeImport-Tests'!

!ChunkImportTestCase methodsFor: 'auxiliar' stamp: 'GuillermoPolito 5/5/2012 01:57'!
importAClass
	^ChunkImporter readStream: 'Object subclass: #CodeImportTestCaseTestClass
			instanceVariableNames: ''var1 var2 var3''
			classVariableNames: ''''
			poolDictionaries: ''''
			category: ''CodeImporter-Tests-Garbage''!!' readStream.! !

!ChunkImportTestCase methodsFor: 'testing' stamp: 'GuillermoPolito 5/5/2012 01:57'!
testImportAClass
	| class |
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		self assert: #CodeImportTestCaseTestClass equals: class name.
		self assert: (class instVarNames includes: 'var1').
		self assert: (class instVarNames includes: 'var1').
		self assert: (class instVarNames includes: 'var1').
		self assert: class category equals: 'CodeImporter-Tests-Garbage'.
		
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'testing' stamp: 'GuillermoPolito 5/5/2012 02:20'!
testImportAClassCategory
	| class classOrganizationString chunk |
	classOrganizationString := '(''testing'' testImportAClass testImportAMethod)
(''auxiliar'' importAClass)'.
	chunk := '!!{1} reorganize!!'.
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		
		"we write the methods we will categorize"
		class compileSilently: 'testImportAClass'.
		class compileSilently: 'testImportAMethod'.
		class compileSilently: 'importAClass'.
		
		ChunkImporter readString: (chunk format: { class name asString }), classOrganizationString.
		self assert: classOrganizationString trimBoth equals: class organization stringForFileOut trimBoth.
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'testing' stamp: 'GuillermoPolito 5/5/2012 02:01'!
testImportAClassComment
	| class comment |
	comment := 'I''m a nice comment, treat me well :).'.
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		ChunkImporter readString: ('!!{1} commentStamp: ''<historical>'' prior: 0!!{2}!!' format: { class name asString . comment }).
		self assert: comment equals: class comment.
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'testing' stamp: 'GuillermoPolito 5/5/2012 02:03'!
testImportAMethod
	| class comment |
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		ChunkImporter readString: ('!!{1} methodsFor: ''some protocol'' stamp: ''GuillermoPolito 5/2/2012 13:35''!!someMethod
	^true' format: { class name asString }).
	
		self assert: class new someMethod.
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'testing' stamp: 'GuillermoPolito 5/5/2012 01:41'!
testImportSimpleExpression
	self assert: 4 equals: (ChunkImporter readStream: '2+2!!' readStream)! !

!ChunkImportTestCase methodsFor: 'testing' stamp: 'GuillermoPolito 5/5/2012 01:55'!
testImportString
	self assert: 4 equals: (ChunkImporter readString: '2+2!!')! !
